class DirtWall extends State
{
   var mcRef;
   var nWaitTime;
   static var sLINKAGE_NAME = "mcDirtWall";
   var sSTATE_IDLE = "Idle";
   var sSTATE_FALL = "Fall";
   static var nMIN_WAIT_TIME = 200;
   static var nMAX_WAIT_TIME = 500;
   static var nCOUNTER = 0;
   function DirtWall(_nX, _nY)
   {
      super(CTRLGame.getRef().mcRef.attachMovie(DirtWall.sLINKAGE_NAME,DirtWall.sLINKAGE_NAME + DirtWall.nCOUNTER,CTRLGame.getRef().calculateDepth(_nY,CTRLGame.nDIRT_WALL_ADD + DirtWall.nCOUNTER)));
      DirtWall.nCOUNTER = DirtWall.nCOUNTER + 1;
      this.mcRef._x = _nX;
      this.mcRef._y = _nY;
      this.nWaitTime = Math.round(Math.random() * (DirtWall.nMAX_WAIT_TIME - DirtWall.nMIN_WAIT_TIME)) + DirtWall.nMIN_WAIT_TIME;
      if(this.nWaitTime == 0)
      {
         this.setState(this.sSTATE_FALL);
      }
      else
      {
         this.setState(this.sSTATE_IDLE);
      }
      if(Controller.getRef().isPaused())
      {
         this.doPause();
      }
   }
   function cleanUp()
   {
      super.cleanUp();
      this.mcRef.swapDepths(7777);
      this.mcRef.removeMovieClip();
   }
   function doPause()
   {
      super.doPause();
      for(var i in this.mcRef.mcState)
      {
         this.mcRef.mcState[i].stop();
      }
   }
   function doUnPause()
   {
      if(!CTRLGame.getRef().Screen.isInMiniGame())
      {
         super.doUnPause();
         for(var i in this.mcRef.mcState)
         {
            this.mcRef.mcState[i].play();
         }
      }
   }
   function resumeAnim()
   {
      super.doUnPause();
      for(var i in this.mcRef.mcState)
      {
         this.mcRef.mcState[i].play();
      }
   }
   function Idle()
   {
      if(!Controller.getRef().isPaused() && !CTRLGame.getRef().Screen.isInMiniGame())
      {
         this.nWaitTime = this.nWaitTime - 1;
         if(this.nWaitTime <= 0)
         {
            this.setState(this.sSTATE_FALL);
         }
      }
   }
   function Fall()
   {
      if(!Controller.getRef().isPaused() && !CTRLGame.getRef().Screen.isInMiniGame())
      {
         if(this.stateFinished())
         {
            this.setState(this.sSTATE_IDLE);
            this.nWaitTime = Math.round(Math.random() * (DirtWall.nMAX_WAIT_TIME - DirtWall.nMIN_WAIT_TIME)) + DirtWall.nMIN_WAIT_TIME;
         }
      }
   }
}
