class MinigameTransition extends State
{
   var bIsLeft;
   var sState;
   var sGoingTo;
   var mcRef;
   static var sSTATE_IDLE = "Idle";
   static var sSTATE_PLAY_LEFT = "PlayLeft";
   static var sSTATE_PLAY_RIGHT = "PlayRight";
   static var nFRAME_CHANGE = 15;
   function MinigameTransition(_mcRef)
   {
      super(_mcRef);
      this.setState(MinigameTransition.sSTATE_IDLE);
      this.bIsLeft = !!Math.round(Math.random());
   }
   function isInIdle()
   {
      var _loc2_ = false;
      if(this.sState == MinigameTransition.sSTATE_IDLE)
      {
         _loc2_ = true;
      }
      return _loc2_;
   }
   function goTo(_sGoingTo)
   {
      this.sGoingTo = _sGoingTo;
      if(this.sState == MinigameTransition.sSTATE_IDLE)
      {
         if(this.bIsLeft)
         {
            this.setState(MinigameTransition.sSTATE_PLAY_RIGHT);
            this.bIsLeft = false;
         }
         else
         {
            this.setState(MinigameTransition.sSTATE_PLAY_LEFT);
            this.bIsLeft = true;
         }
      }
   }
   function doPause()
   {
   }
   function doUnPause()
   {
   }
   function managePlayAnim()
   {
      if(this.stateFinished())
      {
         this.setState(MinigameTransition.sSTATE_IDLE);
      }
      else if(this.mcRef.mcState._currentframe == MinigameTransition.nFRAME_CHANGE)
      {
         CTRLGame.getRef().Screen.setState(this.sGoingTo);
      }
   }
   function Idle()
   {
   }
   function PlayLeft()
   {
      this.managePlayAnim();
   }
   function PlayRight()
   {
      this.managePlayAnim();
   }
}
